-- Insert SQL Rules Here

UPDATE CitySpecialization_TargetYields
SET Yield = 50
WHERE YieldType = 'YIELD_FOOD';

--
-- Unit Priorities
--

DELETE FROM Unit_Flavors
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_CARRIER',
	'UNITCLASS_SCOUT'
));

UPDATE Unit_Flavors SET Flavor = 1
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_WARRIOR'
));

UPDATE Unit_Flavors SET Flavor = 2
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_TRIREME',
	'UNITCLASS_ARCHER',
	'UNITCLASS_SPEARMAN'
)) OR UnitType IN (
	'UNIT_AZTEC_JAGUAR'
);

UPDATE Unit_Flavors SET Flavor = 3
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_CATAPULT'
)) OR UnitType IN (
	'UNIT_GREEK_HOPLITE',
	'UNIT_PERSIAN_IMMORTAL'
);

UPDATE Unit_Flavors SET Flavor = 4
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_CHARIOT_ARCHER',
	'UNITCLASS_HORSEMAN',
	'UNITCLASS_SWORDSMAN',

	'UNITCLASS_CARAVEL',
	'UNITCLASS_PIKEMAN',
	'UNITCLASS_LEVY'
));

UPDATE Unit_Flavors SET Flavor = 6
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_CROSSBOWMAN',
	'UNITCLASS_TREBUCHET'
));

UPDATE Unit_Flavors SET Flavor = 8
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_KNIGHT',
	'UNITCLASS_LONGSWORDSMAN',

	'UNITCLASS_FRIGATE',
	'UNITCLASS_MUSKETMAN'
));

UPDATE Unit_Flavors SET Flavor = 12
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_SKIRMISHER',
	'UNITCLASS_SHIP_OF_THE_LINE',
	'UNITCLASS_CANNON'
)) OR UnitType IN (
	'UNIT_FRENCH_MUSKETEER'
);

UPDATE Unit_Flavors SET Flavor = 16
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_LANCER',
	'UNITCLASS_CAVALRY',
	'UNITCLASS_RIFLEMAN',

	'UNITCLASS_SUBMARINE',
	'UNITCLASS_DESTROYER'
)) OR UnitType IN (
	'UNIT_AMERICAN_MINUTEMAN'
);

UPDATE Unit_Flavors SET Flavor = 24
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_ARTILLERY',
	'UNITCLASS_IRONCLAD',
	'UNITCLASS_ANTI_TANK_GUN',
	'UNITCLASS_ANTI_AIRCRAFT_GUN',
	'UNITCLASS_LIGHT_INFANTRY',
	'UNITCLASS_INFANTRY'
));

UPDATE Unit_Flavors SET Flavor = 32
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_NUCLEAR_SUBMARINE',
	'UNITCLASS_BATTLESHIP',
	'UNITCLASS_FIGHTER',
	'UNITCLASS_BOMBER',
	'UNITCLASS_TANK',

	'UNITCLASS_PARATROOPER',
	'UNITCLASS_MECHANIZED_INFANTRY',
	'UNITCLASS_MOBILE_SAM',
	'UNITCLASS_GUIDED_MISSILE',
	'UNITCLASS_HELICOPTER_GUNSHIP',
	'UNITCLASS_ATOMIC_BOMB'
));

UPDATE Unit_Flavors SET Flavor = 64
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_MISSILE_CRUISER',
	'UNITCLASS_ROCKET_ARTILLERY',
	'UNITCLASS_JET_FIGHTER',
	'UNITCLASS_STEALTH_BOMBER',
	'UNITCLASS_MODERN_ARMOR',
	'UNITCLASS_NUCLEAR_MISSILE'
));

UPDATE Unit_Flavors SET Flavor = 128
WHERE UnitType IN (SELECT Type FROM Units WHERE Class IN (
	'UNITCLASS_MECH'
));






UPDATE Unit_Flavors SET Flavor = ROUND(Flavor * 1.5, 0)
WHERE FlavorType = 'FLAVOR_DEFENSE' 
AND UnitType IN (SELECT Type FROM Units WHERE CombatClass IN (
	'UNITCOMBAT_ARCHER',
	'UNITCOMBAT_MOUNTED_ARCHER',
	'UNITCOMBAT_FIGHTER',
	'UNITCOMBAT_BOMBER'
));

UPDATE Unit_Flavors SET Flavor = ROUND(Flavor * 0.67, 0)
WHERE FlavorType = 'FLAVOR_DEFENSE' 
AND UnitType IN (SELECT UnitType FROM Unit_ResourceQuantityRequirements); 

--
-- Promotion Priorities
--

-- It appears OrderPriority controls only UI display, not any actual gameplay...
/*
UPDATE UnitPromotions
SET OrderPriority = 32
WHERE Type IN (
	'PROMOTION_MARCH',
	'PROMOTION_AIR_LOGISTICS',
	'PROMOTION_MARCH_VANGUARD',
	'PROMOTION_LOGISTICS'
);

UPDATE UnitPromotions
SET OrderPriority = 16
WHERE Type IN (
	'PROMOTION_CHARGE',
	'PROMOTION_INDIRECT_FIRE',
	'PROMOTION_RANGE',
	'PROMOTION_MEDIC'
);

UPDATE UnitPromotions
SET OrderPriority = 8
WHERE Type IN (
	'PROMOTION_BLITZ',
	'PROMOTION_MARCH_RANGED',
	'PROMOTION_TRENCHES_1',
	'PROMOTION_TRENCHES_2',
	'PROMOTION_TRENCHES_3',
	'PROMOTION_TARGETING_1',
	'PROMOTION_TARGETING_2',
	'PROMOTION_TARGETING_3',
	
	'PROMOTION_SIEGE',
	'PROMOTION_AMBUSH_1'
);

UPDATE UnitPromotions
SET OrderPriority = 4
WHERE Type IN (
	'PROMOTION_SHOCK_1',
	'PROMOTION_SHOCK_2',
	'PROMOTION_SHOCK_3',
	'PROMOTION_BARRAGE_1',
	'PROMOTION_BARRAGE_2',
	'PROMOTION_BARRAGE_3',
	'PROMOTION_SCOUTING_1',
	'PROMOTION_SCOUTING_2',
	'PROMOTION_NAVAL_RECON_1',
	'PROMOTION_NAVAL_RECON_2',
	
	'PROMOTION_NAVAL_SIEGE',
	'PROMOTION_COVER_1',
	'PROMOTION_COVER_2',
	'PROMOTION_COVER_VANGUARD_1',
	'PROMOTION_COVER_VANGUARD_2',
	'PROMOTION_VOLLEY',
	'PROMOTION_SKIRMISH'
);

UPDATE UnitPromotions
SET OrderPriority = 1
WHERE Type IN (
	'PROMOTION_DRILL_1',
	'PROMOTION_DRILL_2',
	'PROMOTION_DRILL_3',
	'PROMOTION_ACCURACY_1',
	'PROMOTION_ACCURACY_2',
	'PROMOTION_ACCURACY_3',
	'PROMOTION_GUERRILLA_1',
	'PROMOTION_GUERRILLA_2',
	'PROMOTION_GUERRILLA_3',
	'PROMOTION_BOMBARDMENT_1',
	'PROMOTION_BOMBARDMENT_2',
	'PROMOTION_BOMBARDMENT_3',

	'PROMOTION_AMBUSH_2'
);
*/